;*************************************************
;*************************************************
;***                                           ***
;***  AVR logic analizer "NekologiAVR"         ***
;***            for at-MEGA48 20MHz            ***
;***                                           ***
;***      with 62256(55ns)S-RAM & 74HC4040     ***
;***      connected to PC with UART(115200bps) ***
;***                                           ***
;***                        m.suga             ***
;***                        created 2008.3.9   ***
;***                                           ***
;***   modified 2010.12.21                     ***
;***       add  xon/xoff flow control          ***
;***                                           ***
;*************************************************
;*************************************************



	;*******************
	;*****  `  *****
	;*******************

	;*****  `t@C  *****

.include "m48def.inc"


	;*****  WX^  *****

.def data1 = R16			;Ǐpr̔ėpWX^
.def out_data = R17			;UARTo͗pf[^iTunpj
.def sample_zh = R18		;Tv[gjmp
.def sample_zl = R19		;  WvAhX
.def sample_rate = R20		;Tv[g̎
.def data2 = R21			;f[^Q
.def data3 = R22			;f[^R
.def sram_add = R23			;rq`lAhXwp
.def first_byte = R24		;1oCgڂ͕̓
.def second_byte = R25		;2oCgڂ͕̓



.def triger = R11			;gK[̎
.def chk_sum_h = R9			;`FbNT̏
.def chk_sum_l = R8			;`FbNT̉
.def l_count1 = R7			;ėpJE^P
.def l_count2 = R6			;ėpJE^Q
.def l_count3 = R5			;ėpJE^Q




	;*****  萔  *****



	;*************************
	;*****  Zbg  *****
	;*************************

.org 0x00				;Zbg̃X^[gԒn
	rjmp	RESET		;ZbgƂɂOԒnRESETɑ΃Wv
	rjmp	EX_INT0		;O݂OƂ̃Wv
						;̑̊荞݂͕sƂ



RESET:

	;***********************
	;*****    *****
	;***********************

	;*****  X^bN|C^ݒ  *****

	ldi		data1,low(RAMEND)	;data1SP̉ʃAhXZbg
	out		SPL,data1			;SPLdata1Zbg
	ldi		data1,high(RAMEND)	;data1SP̏ʃAhXZbg
	out		SPH,data1			;SPHdata1Zbg


	;*****  Ăяo  *****

	rcall	INITIALIZE




MAIN_LOOP:

	;*************************
	;*****  C[v  *****
	;*************************


	;*****  rq`l  *****

	sbi		portB,2		;/weMhighɁiXg[uItj
	sbi		portB,3		;/oeMhighɁiXg[uItj


	ldi		sram_add,0
	out		portd,sram_add	;SRAM̃AhXw0
							;@iSRAM̐擪AhXjw
							;74HC4040mr̓It̂܂

	sbi		portD,3		;74HC4040̃}X^[NA
	cbi		portD,3		;ɖ߂




	;********************************
	;*****  ̓͂ƐU蕪  *****
	;********************************


MA_LOOP1:
	;*****  t`qs͂̃[v  *****

	lds		data1,UCSR0A
	andi	data1,(1<<RXC0)	;Mobt@Ƀf[^邩`FbN

	breq	MA_LOOP1		;obt@Ƀf[^iRXC=0jȂ烋[v


	tst		first_byte		;f[^V[PX1oCgڂmF
	brne	MA_CHK2			;2oCgڂȂMA_CHK2


	;*****  t`qś@1oCg  *****

	lds		first_byte,UDR0

	rjmp	MA_LOOP1


	;*****  t`qś@2oCg  *****
MA_CHK2:

	lds		second_byte,UDR0


	;**************************************
	;*****  t`qs͓eƂ̏  *****
	;**************************************

	;***************************************
	;*****  1ڂ̏ꍇ̐U蕪  *****
	;***************************************

	cpi		first_byte,'m'
	brne	NOT_m

	cpi		second_byte,'e'
	breq	MA_CHK3
	
	rjmp	ERROR_OUT			;meŖ΃G[


MA_CHK3:
	ldi		zl,low(me * 2)
	ldi		zh,high(me * 2)		;eʂ̕

	rcall	STRING				;Œ蕶o

	rcall	CRLF				;so

	ldi		first_byte,0
	ldi		second_byte,0		;obt@NA


	rjmp	MA_LOOP1			;[vɖ߂




	;***************************************
	;*****  1ڂ̏ꍇ̐U蕪  *****
	;***************************************
NOT_m:
	cpi		first_byte,'s'
	breq	IS_s

	rjmp	NOT_s

IS_s:
	cpi		second_byte,'t'		;R}hH
	brne	NOT_st

	rjmp	START_SAMPLING		;R}h̎s


NOT_st:
	cpi		second_byte,'r'		;R}hH
	brne	NOT_sr

	ldi		zl,low(sr * 2)
	ldi		zh,high(sr * 2)		;Tv[g̕

	rcall	STRING				;Œ蕶o

	rcall	CRLF				;so

	ldi		first_byte,0
	ldi		second_byte,0		;obt@NA


	rjmp	MA_LOOP1			;[vɖ߂
	


NOT_sr:
	cpi		second_byte,'0'		;OR}hH
	brne	NOT_s0

	ldi		sample_rate,0		;Tv[gύX
	ldi		sample_zh,high(SR_0)
	ldi		sample_zl,low(SR_0)	;WvAhXݒ

	rjmp	Sx_CHANGE_OK		;ύXbZ[Wo

NOT_s0:
	cpi		second_byte,'1'		;PR}hH
	brne	NOT_s1

	ldi		sample_rate,1		;Tv[gύX
	ldi		sample_zh,high(SR_1)
	ldi		sample_zl,low(SR_1)	;WvAhXݒ

	rjmp	Sx_CHANGE_OK		;ύXbZ[Wo

NOT_s1:
	cpi		second_byte,'2'		;QR}hH
	brne	NOT_s2

	ldi		sample_rate,2		;Tv[gύX
	ldi		sample_zh,high(SR_2)
	ldi		sample_zl,low(SR_2)	;WvAhXݒ

	rjmp	Sx_CHANGE_OK		;ύXbZ[Wo

NOT_s2:
	cpi		second_byte,'3'		;RR}hH
	brne	NOT_s3

	ldi		sample_rate,3		;Tv[gύX
	ldi		sample_zh,high(SR_3)
	ldi		sample_zl,low(SR_3)	;WvAhXݒ

	rjmp	Sx_CHANGE_OK		;ύXbZ[Wo

NOT_s3:
	cpi		second_byte,'4'		;SR}hH
	brne	NOT_s4

	ldi		sample_rate,4		;Tv[gύX
	ldi		sample_zh,high(SR_4)
	ldi		sample_zl,low(SR_4)	;WvAhXݒ

	rjmp	Sx_CHANGE_OK		;ύXbZ[Wo

NOT_s4:
	cpi		second_byte,'5'		;TR}hH
	brne	NOT_s5

	ldi		sample_rate,5		;Tv[gύX
	ldi		sample_zh,high(SR_5)
	ldi		sample_zl,low(SR_5)	;WvAhXݒ

	rjmp	Sx_CHANGE_OK		;ύXbZ[Wo

NOT_s5:
	cpi		second_byte,'6'		;UR}hH
	brne	NOT_s6

	ldi		sample_rate,6		;Tv[gύX
	ldi		sample_zh,high(SR_6)
	ldi		sample_zl,low(SR_6)	;WvAhXݒ

	rjmp	Sx_CHANGE_OK		;ύXbZ[Wo

NOT_s6:
	cpi		second_byte,'7'		;VR}hH
	brne	NOT_s7

	ldi		sample_rate,7		;Tv[gύX
	ldi		sample_zh,high(SR_7)
	ldi		sample_zl,low(SR_7)	;WvAhXݒ

	rjmp	Sx_CHANGE_OK		;ύXbZ[Wo

NOT_s7:
	cpi		second_byte,'8'		;WR}hH
	brne	NOT_s8

	ldi		sample_rate,8		;Tv[gύX
	ldi		sample_zh,high(SR_8)
	ldi		sample_zl,low(SR_8)	;WvAhXݒ

	rjmp	Sx_CHANGE_OK		;ύXbZ[Wo

NOT_s8:
	cpi		second_byte,'9'		;XR}hH
	brne	NOT_s9

	ldi		sample_rate,9		;Tv[gύX
	ldi		sample_zh,high(SR_9)
	ldi		sample_zl,low(SR_9)	;WvAhXݒ

	rjmp	Sx_CHANGE_OK		;ύXbZ[Wo

NOT_s9:
	cpi		second_byte,'a'		;R}hH
	brne	NOT_sa

	ldi		sample_rate,10		;Tv[gύX
	ldi		sample_zh,high(SR_A)
	ldi		sample_zl,low(SR_A)	;WvAhXݒ

	rjmp	Sx_CHANGE_OK		;ύXbZ[Wo

NOT_sa:
	cpi		second_byte,'b'		;R}hH
	brne	OTHER_s

	ldi		sample_rate,11		;Tv[gύX
	ldi		sample_zh,high(SR_B)
	ldi		sample_zl,low(SR_B)	;WvAhXݒ

	rjmp	Sx_CHANGE_OK		;ύXbZ[Wo


OTHER_s:
	rjmp	ERROR_OUT			;2ڂs
								;ꍇ̓G[o͂




Sx_CHANGE_OK:
	ldi		zl,low(change_ok * 2)
	ldi		zh,high(change_ok * 2)	;ύXnj̕

	rcall	STRING				;Œ蕶o

	mov		data3,first_byte	;1ڏo
	rcall	UART_OUT

	mov		data3,second_byte	;2ڏo
	rcall	UART_OUT

	rcall	CRLF				;so

	ldi		first_byte,0
	ldi		second_byte,0		;obt@NA


	rjmp	MA_LOOP1			;[vɖ߂



	;*****  TvOJn̏  *****
START_SAMPLING:

	ldi		first_byte,0
	ldi		second_byte,0		;obt@NA

	mov		zh,sample_zh
	mov		zl,sample_zl		;Tv[g
								;@Wvyɐݒ

	sbi		EIFR,INTF0			;荞ݗṽNA
	sei							;荞݋

	ldi		data1,0
	cp		triger,data1
	brne	SS1
	rjmp	TG_FREE_RUN			;gKOȂt[

SS1:
	ldi		data1,1
	cp		triger,data1
	brne	SS2
	rjmp	TG_FALL_EDGE		;gKPȂ痧Gba

SS2:
	rjmp	TG_RISE_EDGE		;gKQȂ痧オGba





	;**************************************
	;***** 1ڂ̏ꍇ̐U蕪  *****
	;**************************************
NOT_s:
	cpi		first_byte,'t'
	breq	IS_t
	
	rjmp	ERROR_OUT

IS_t:
	cpi		second_byte,'0'		;OR}hH
	brne	NOT_t0

	ldi		data1,0
	mov		triger,data1		;gKOɕύX


	ldi		zl,low(change_ok * 2)
	ldi		zh,high(change_ok * 2)	;ύXnj̕

	rcall	STRING				;Œ蕶o
								;change_ok : t0

	mov		data3,first_byte	;1ڏo
	rcall	UART_OUT

	mov		data3,second_byte	;2ڏo
	rcall	UART_OUT

	rcall	CRLF				;so

	ldi		first_byte,0
	ldi		second_byte,0		;obt@NA


	rjmp	MA_LOOP1			;[vɖ߂


NOT_t0:
	cpi		second_byte,'1'		;PR}hH
	brne	NOT_t1

	ldi		data1,1
	mov		triger,data1		;gKPɕύX


	ldi		zl,low(change_ok * 2)
	ldi		zh,high(change_ok * 2)	;ύXnj̕

	rcall	STRING				;Œ蕶o
								;change_ok : t1

	mov		data3,first_byte	;1ڏo
	rcall	UART_OUT

	mov		data3,second_byte	;2ڏo
	rcall	UART_OUT

	rcall	CRLF				;so

	ldi		first_byte,0
	ldi		second_byte,0		;obt@NA


	rjmp	MA_LOOP1			;[vɖ߂


NOT_t1:
	cpi		second_byte,'2'		;QR}hH
	brne	NOT_t2

	ldi		data1,2
	mov		triger,data1		;gKQɕύX


	ldi		zl,low(change_ok * 2)
	ldi		zh,high(change_ok * 2)	;ύXnj̕

	rcall	STRING				;Œ蕶o
								;change_ok : t2

	mov		data3,first_byte	;1ڏo
	rcall	UART_OUT

	mov		data3,second_byte	;2ڏo
	rcall	UART_OUT

	rcall	CRLF				;so

	ldi		first_byte,0
	ldi		second_byte,0		;obt@NA


	rjmp	MA_LOOP1			;[vɖ߂



NOT_t2:
	cpi		second_byte,'g'		;R}hH
	brne	ERROR_OUT

	ldi		zl,low(tg * 2)
	ldi		zh,high(tg * 2)

	rcall	STRING				;Œ蕶o

	rcall	CRLF				;so

	ldi		first_byte,0
	ldi		second_byte,0		;obt@NA


	rjmp	MA_LOOP1			;[vɖ߂



	;**************************************
	;*****  ǂɂĂ͂܂Ȃꍇ  *****
	;**************************************
ERROR_OUT:
	ldi		zl,low(error_command * 2)
	ldi		zh,high(error_command * 2)

	rcall	STRING				;Œ蕶o

	mov		data3,first_byte	;1ڏo
	rcall	UART_OUT

	mov		data3,second_byte	;1ڏo
	rcall	UART_OUT

	rcall	CRLF				;so

	ldi		first_byte,0
	ldi		second_byte,0		;obt@NA


	rjmp	MA_LOOP1			;[vɖ߂







	;**************************************
	;*****  TvOʂ̑M  *****
	;**************************************

OUTPUT_RESULT:

	;*****  rq`l  *****
	sbi		portB,2		;/weMhigh
	sbi		portB,3		;/oeMhigh

	ldi		sram_add,0
	out		portd,sram_add	;SRAM̃AhXw0
							;@iSRAM̐擪AhXjw
							;74HC4040mr̓It̂܂


	;*****  VSgbSOSO  *****

	sbi		portD,3		;74HC4040̃}X^[NA
	cbi		portD,3		;ɖ߂


	;*****  ʂ1sڃbZ[Wo  *****

	ldi		zl,low(me * 2)
	ldi		zh,high(me * 2)

	rcall	STRING				;Œ蕶o 1


	ldi		data3,','			;Œ蕶o 2
	rcall	UART_OUT
	ldi		data3,'s'
	rcall	UART_OUT
	ldi		data3,'r'
	rcall	UART_OUT
	ldi		data3,','
	rcall	UART_OUT
	ldi		data3,'s'
	rcall	UART_OUT


	cpi		sample_rate,10
	brge	OR_CHK1

	mov		data3,sample_rate
	subi	data3,0-'0'			;data3'0'`'9'Zbg
	rjmp	OR_CHK2

OR_CHK1:
	mov		data3,sample_rate
	subi	data3,0-('a' - 10)	;data3'a'`'b'Zbg

OR_CHK2:
	rcall	UART_OUT			;'0'`'b'o


	ldi		data3,','			;Œ蕶o 3
	rcall	UART_OUT
	ldi		data3,'t'
	rcall	UART_OUT
	ldi		data3,'g'
	rcall	UART_OUT
	ldi		data3,','
	rcall	UART_OUT
	ldi		data3,'t'
	rcall	UART_OUT

	mov		data3,triger
	subi	data3,0-'0'			;data3'0'`'2'o
	rcall	UART_OUT


	rcall	CRLF				;so



	;*****  ʂ2sڈȍ~ói_v{́j  *****


	ldi		xl,0
	ldi		xh,0		;\pAhXlɃZbg


	cbi		portB,3		;/oeMlowɁiǂݏoXg[uj
						;iǂݏoԂ̂܂܃AhXςčsj


	ldi		data1,8
	mov		l_count3,data1		;8񃋁[v
MA_LOOP3:
	ldi		data1,0
	mov		l_count1,data1		;256񃋁[v
MA_LOOP4:

	;*****  `FbNT̏  *****

	clr		chk_sum_h
	clr		chk_sum_l


	;*****  AhXSƃJ}̏o  *****
	mov		out_data,xh
	rcall	OUT_HEX

	mov		out_data,xl
	rcall	OUT_HEX

	ldi		data3,','
	rcall	UART_OUT


	ldi		data1,16
	mov		l_count2,data1		;16񃋁[v
MA_LOOP5:


	;*****  PoCg̃f[^S-RAMǂݏo  *****
	out		portD,sram_add	;AhXwo

	nop
	nop

	in		data1,PINC		;pinCǂݍ
	lsl		data1
	lsl		data1			;pinC2rbgVtg

	in		data2,pinB		;pinBǂݍ
	andi	data2,0b00000011	;2rbgo

	or		data2,data1		;portCportB̓͂

	subi	sram_add,-16	;ǂݏoAhX{PU


	;*****  PoCg̃f[^o͏  *****
	mov		out_data,data2
	rcall	OUT_HEX


	;*****  `FbNŤvZ  *****
	add		chk_sum_l,data2
	brcc	MA_CHK4
	inc		chk_sum_h
MA_CHK4:

	ldi		data3,','
	rcall	UART_OUT




	dec		l_count2
	mov		data1,l_count2
	cpi		data1,0


	brne	MA_LOOP5		;1oCgo͂PUJԂ



	;*****  `FbNTói2oCgj  *****
	mov		out_data,chk_sum_h
	rcall	OUT_HEX

	mov		out_data,chk_sum_l
	rcall	OUT_HEX



	;*****  AhX̃CNg(+16)  *****
	adiw	xl,16


	;*****  cr/lfo  *****
	rcall	CRLF



	dec		l_count1
	mov		data1,l_count1
	cpi		data1,0
	brne	MA_LOOP4		;~QTU

	dec		l_count3
	mov		data1,l_count3
	cpi		data1,0
	brne	MA_LOOP3		;~W@@RQa



	cbi		portB,3		;/oeMhighɁiǂݏoIj



	rjmp	MAIN_LOOP	;MAIN LOOPɖ߂







	;*************************
	;*****  Tu[`  *****
	;*************************


	;*****                 *****
	;*****    *****
	;*****                 *****
INITIALIZE:

	;*****  o̓|[g̐ݒ  *****

	ldi		data1,0b11111010	;OAQrbgȊOĂ
	out		DDRD,data1			;ocOAQ͂ɃZbg

	ldi		data1,0b00111111	;O`T𗧂Ă
	out		PORTC,data1			;obO`TvAbvݒ
	ldi		data1,0b00000000	;ׂăNA
	out		DDRC,data1			;obׂē͂ɃZbg

	ldi		data1,0b00000011	;O`P𗧂Ă
	out		PORTB,data1			;oaOAPvAbvݒ
	ldi		data1,0b11111100	;OCPȊOĂ
	out		DDRB,data1			;oaOAP͂ɃZbg



	;*****  RS232C@  *****

	ldi		data1,0
	sts		UCSR0B,data1		;܂AUfB[[uɐݒ
	sts		UCSR0A,data1		;ׂăNA

	ldi		data1,((1<<UCSZ01)|(1<<UCSZ00))
	sts		UCSR0C,data1		;8rbgAmpAXgbvP

	ldi		data1,0x00
	sts		UBRR0H,data1		;4rbg
	ldi		data1,0x0a
	sts		UBRR0L,data1		;8rbg
								;UBRR = 0x411 = 1041 (=1200bps @20MHz)
								;UBRR = 0x040 = 0064 (=19.2kbps @20MHz)
								;UBRR = 0x015 = 0021 (=57.6kbps @20MHz)
								;UBRR = 0x00A = 0010 (=115.2kbps @20MHz)


	ldi		data1,(1<<TXEN0|1<<RXEN0)
	sts		UCSR0B,data1		;ݒ芮ɁAMCl[uݒ



	;*****  グ܂łɃ^CO  *****

	ldi		data1,255
	mov		l_count1,data1
IN_LOOP1:
	ldi		data1,255
	mov		l_count2,data1
IN_LOOP2:
	nop
	nop
	nop
	nop
	nop

	dec		l_count2
	mov		data1,l_count2
	cpi		data1,0
	brne	IN_LOOP2

	dec		l_count1
	mov		data1,l_count1
	cpi		data1,0
	brne	IN_LOOP1			;30msx̃^CO



	;*****  VSgbSOSO  *****

	sbi		portD,3		;74HC4040̃}X^[NA
	cbi		portD,3		;ɖ߂



	;*****  荞ݐݒ  *****

	cli					;stR}hM܂ł͊荞݋֎~Ƃ

	ldi		data1,0b00000011	;ӂ(PD2=INT0)͗オGba=11
	sts		EICRA,data1

	ldi		data1,0b00000001
	out		EIMSK,data1			;INT0̊O݉ɐݒ



	;*****  l̐ݒ  *****

	ldi		data1,0
	mov		first_byte,data1	;1oCgڂ͕̓NA
	mov		second_byte,data1	;2oCgڂ͕̓NA

	mov		triger,data1		;gK̎ʁilj
	mov		sample_rate,data1	;Tv[g̎ʁilj

	ldi		data1,high(SR_0)
	mov		sample_zh,data1		;Tv[gɉ
	ldi		data1,low(SR_0)
	mov		sample_zl,data1		;  jmpAhX

	clr		chk_sum_h
	clr		chk_sum_l			;`FbNT



	ret							;I





	;*****                   *****
	;*****  UARTo̓Tu  *****
	;*****                   *****
UART_OUT:
								;xoffM̏ꍇAxonM܂ő҂
								;̌UDRE܂ő҂Ăf[^o

	lds		data1,UCSR0A
	andi	data1,(1<<RXC0)	;Mobt@Ƀf[^邩`FbN
	breq	UO_LOOP1		;obt@Ƀf[^iRXC=0jȂ瑗M

	lds		data1,UDR0		;PoCgǂݏo

	cpi		data1,0x13		;xoff(0x13)Ɣr
	brne	UART_OUT		;xoffłȂꍇ́AɂȂ܂ŌJԂiǂ݁j


UO_LOOP2:
	lds		data1,UCSR0A
	andi	data1,(1<<RXC0)	;Mobt@Ƀf[^邩`FbN
	breq	UO_LOOP2		;obt@Ƀf[^iRXC=0jȂ҂

	lds		data1,UDR0		;PoCgǂݏo

	cpi		data1,0x11		;xon(0x11)Ɣr
	brne	UO_LOOP2		;xon͂܂ŌJԂ



UO_LOOP1:
	lds		data1,UCSR0A		;UCSRAǂݍ
	andi	data1,(1<<UDRE0)	;UDREĂ邩`FbN
	breq	UO_LOOP1			;܂ŌJԂ

	sts		UDR0,data3		;f[^o


	ret							;߂



	;*****                       *****
	;*****  HEXASCIITu  *****
	;*****                       *****
OUT_HEX:

	mov		data3,out_data
	andi	data3,0xf0
	swap	data3

	cpi		data3,10
	brcc	OH_CHK1

	subi	data3,(0-'0')
	rjmp	OH_CHK2

OH_CHK1:
	subi	data3,(0-('A'-10))

OH_CHK2:
	rcall	UART_OUT


	mov		data3,out_data
	andi	data3,0x0f


	cpi		data3,10
	brcc	OH_CHK3

	subi	data3,(0-'0')
	rjmp	OH_CHK4

OH_CHK3:
	subi	data3,(0-('A'-10))

OH_CHK4:
	rcall	UART_OUT


	ret							;߂





	;*****                       *****
	;*****  CR/LFo̓Tu  *****
	;*****                       *****
CRLF:

	ldi		data3,13
	rcall	UART_OUT

	ldi		data3,10
	rcall	UART_OUT


	ret							;߂




	;*****                     *****
	;*****  o̓Tu  *****
	;*****                     *****
STRING:
							;wwƂ̕o
							;delimiter0x00

	lpm		data3,Z+		;1o

	cpi		data3,0x00		;delimiterH
	breq	ST_END			;ȂI

	rcall	UART_OUT		;UARTɏo͂
	rjmp	STRING			;JԂ

ST_END:

	ret							;߂





	;*****                          *****
	;*****  trigger = free run  *****
	;*****                          *****
TG_FREE_RUN:

	ijmp		;yWX^jmp
				;iyWX^ɂ͊YTv[g
				;@AhXZbgĂj



	;*****                          *****
	;*****  trigger = fall edge  *****
	;*****                          *****
TG_FALL_EDGE:

	in		data1,PINB
	andi	data1,0b00000001
	breq	TG_FALL_EDGE	;܂ghfgxɂȂ܂ő҂

TG_FALL_EDGE0:

	in		data1,PINB
	andi	data1,0b00000001
	brne	TG_FALL_EDGE0	;ɂȂ܂Ń[v

	ijmp		;yWX^jmp
				;iyWX^ɂ͊YTv[g
				;@AhXZbgĂj



	;*****                          *****
	;*****  trigger = rise edge  *****
	;*****                          *****
TG_RISE_EDGE:

	in		data1,PINB
	andi	data1,0b00000001
	brne	TG_RISE_EDGE	;܂knvxɂȂ܂ő҂

TG_RISE_EDGE0:

	in		data1,PINB
	andi	data1,0b00000001
	breq	TG_RISE_EDGE0	;オɂȂ܂Ń[v

	ijmp		;yWX^jmp
				;iyWX^ɂ͊YTv[g
				;@AhXZbgĂj






	;*****                        *****
	;*****  sample rate = s0  *****
	;*****                        *****
SR_0L:

	cbi		PORTB,2			;vdXg[ui݁j
	sbi		PORTB,2			;vdXg[uグiݏIj
SR_0:						;@[v̓
	out		PORTD,sram_add	;rq`lւ̃AhXZbg
	subi	sram_add,-16	;ݐAhX{PU

	rjmp	SR_0L			;JԂi݂܂Ŗ[vj
							;8NbN^1TCNi0.4ʂj



	;*****                        *****
	;*****  sample rate = s1  *****
	;*****                        *****
SR_1L:

	cbi		PORTB,2			;vdXg[ui݁j

	nop
	nop

	sbi		PORTB,2			;vdXg[uグiݏIj
SR_1:						;@[v̓
	out		PORTD,sram_add	;rq`lւ̃AhXZbg
	subi	sram_add,-16	;ݐAhX{PU

	rjmp	SR_1L			;JԂi݂܂Ŗ[vj
							;10NbN^1TCNi0.5ʂj



	;*****                        *****
	;*****  sample rate = s2  *****
	;*****                        *****
SR_2L:
	cbi		PORTB,2			;vdXg[ui݁j

	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop

	sbi		PORTB,2			;vdXg[uグiݏIj
SR_2:						;@[v̓
	out		PORTD,sram_add	;rq`lւ̃AhXZbg
	subi	sram_add,-16	;ݐAhX{PU

	rjmp	SR_2L			;JԂi݂܂Ŗ[vj
							;20NbN^1TCNi1.0ʂj



	;*****                        *****
	;*****  sample rate = s3  *****
	;*****                        *****
SR_3L:
	cbi		PORTB,2			;vdXg[ui݁j


	ldi		data1,3

	mov		l_count1,data1
SR_LOOP3:
	nop
	nop
	nop
	nop
	nop
	nop
	dec		l_count1
	tst		l_count1
	brne	SR_LOOP3		;3 * 10 = 30clk

	nop

	sbi		PORTB,2			;vdXg[uグiݏIj
SR_3:						;@[v̓
	out		PORTD,sram_add	;rq`lւ̃AhXZbg
	subi	sram_add,-16	;ݐAhX{PU

	rjmp	SR_3L			;JԂi݂܂Ŗ[vj
							;40NbN^1TCNi2.0ʂj



	;*****                        *****
	;*****  sample rate = s4  *****
	;*****                        *****
SR_4L:
	cbi		PORTB,2			;vdXg[ui݁j


	ldi		data1,9

	mov		l_count1,data1
SR_LOOP4:
	nop
	nop
	nop
	nop
	nop
	nop
	dec		l_count1
	tst		l_count1
	brne	SR_LOOP4		;9 * 10 = 90clk

	nop

	sbi		PORTB,2			;vdXg[uグiݏIj
SR_4:						;@[v̓
	out		PORTD,sram_add	;rq`lւ̃AhXZbg
	subi	sram_add,-16	;ݐAhX{PU

	rjmp	SR_4L			;JԂi݂܂Ŗ[vj
							;100NbN^1TCNi5.0ʂj




	;*****                        *****
	;*****  sample rate = s5  *****
	;*****                        *****
SR_5L:
	cbi		PORTB,2			;vdXg[ui݁j


	ldi		data1,19

	mov		l_count1,data1
SR_LOOP5:
	nop
	nop
	nop
	nop
	nop
	nop
	dec		l_count1
	tst		l_count1
	brne	SR_LOOP5		;19 * 10 = 190clk

	nop

	sbi		PORTB,2			;vdXg[uグiݏIj
SR_5:						;@[v̓
	out		PORTD,sram_add	;rq`lւ̃AhXZbg
	subi	sram_add,-16	;ݐAhX{PU

	rjmp	SR_5L			;JԂi݂܂Ŗ[vj
							;200NbN^1TCNi10.0ʂj



	;*****                        *****
	;*****  sample rate = s6  *****
	;*****                        *****
SR_6L:
	cbi		PORTB,2			;vdXg[ui݁j


	ldi		data1,39

	mov		l_count1,data1
SR_LOOP6:
	nop
	nop
	nop
	nop
	nop
	nop
	dec		l_count1
	tst		l_count1
	brne	SR_LOOP6		;39 * 10 = 390clk

	nop

	sbi		PORTB,2			;vdXg[uグiݏIj
SR_6:						;@[v̓
	out		PORTD,sram_add	;rq`lւ̃AhXZbg
	subi	sram_add,-16	;ݐAhX{PU

	rjmp	SR_6L			;JԂi݂܂Ŗ[vj
							;400NbN^1TCNi20.0ʂj



	;*****                        *****
	;*****  sample rate = s7  *****
	;*****                        *****
SR_7L:
	cbi		PORTB,2			;vdXg[ui݁j


	ldi		data1,99

	mov		l_count1,data1
SR_LOOP7:
	nop
	nop
	nop
	nop
	nop
	nop
	dec		l_count1
	tst		l_count1
	brne	SR_LOOP7		;99 * 10 = 990clk

	nop

	sbi		PORTB,2			;vdXg[uグiݏIj
SR_7:						;@[v̓
	out		PORTD,sram_add	;rq`lւ̃AhXZbg
	subi	sram_add,-16	;ݐAhX{PU

	rjmp	SR_7L			;JԂi݂܂Ŗ[vj
							;1000NbN^1TCNi50.0ʂj



	;*****                        *****
	;*****  sample rate = s8  *****
	;*****                        *****
SR_8L:
	cbi		PORTB,2			;vdXg[ui݁j


	ldi		data1,199

	mov		l_count1,data1
SR_LOOP8:
	nop
	nop
	nop
	nop
	nop
	nop
	dec		l_count1
	tst		l_count1
	brne	SR_LOOP8		;199 * 10 = 1990clk

	nop

	sbi		PORTB,2			;vdXg[uグiݏIj
SR_8:						;@[v̓
	out		PORTD,sram_add	;rq`lւ̃AhXZbg
	subi	sram_add,-16	;ݐAhX{PU

	rjmp	SR_8L			;JԂi݂܂Ŗ[vj
							;2000NbN^1TCNi100.0ʂj



	;*****                        *****
	;*****  sample rate = s9  *****
	;*****                        *****
SR_9L:
	cbi		PORTB,2			;vdXg[ui݁j


	ldi		data1,199

	mov		l_count1,data1
SR_LOOP9:
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop

	nop
	nop
	nop
	nop
	nop
	nop
	dec		l_count1
	tst		l_count1
	brne	SR_LOOP9		;199 * 20 = 3980clk

	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop

	nop

	sbi		PORTB,2			;vdXg[uグiݏIj
SR_9:						;@[v̓
	out		PORTD,sram_add	;rq`lւ̃AhXZbg
	subi	sram_add,-16	;ݐAhX{PU

	rjmp	SR_9L			;JԂi݂܂Ŗ[vj
							;4000NbN^1TCNi200.0ʂj



	;*****                        *****
	;*****  sample rate = sa  *****
	;*****                        *****
SR_AL:
	cbi		PORTB,2			;vdXg[ui݁j


	ldi		data1,249

	mov		l_count1,data1
SR_LOOPA1:
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop

	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop

	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop

	nop
	nop
	nop
	nop
	nop
	nop
	dec		l_count1
	tst		l_count1
	brne	SR_LOOPA1		;249 * 40 = 9960clk


	ldi		data1,3

	mov		l_count1,data1
SR_LOOPA2:
	nop
	nop
	nop
	nop
	nop
	nop
	dec		l_count1
	tst		l_count1
	brne	SR_LOOPA2		;3 * 10 = 30clk

	sbi		PORTB,2			;vdXg[uグiݏIj
SR_A:						;@[v̓
	out		PORTD,sram_add	;rq`lւ̃AhXZbg
	subi	sram_add,-16	;ݐAhX{PU

	rjmp	SR_AL			;JԂi݂܂Ŗ[vj
							;10000NbN^1TCNi500.0ʂj



	;*****                        *****
	;*****  sample rate = sb  *****
	;*****                        *****
SR_BL:
	cbi		PORTB,2			;vdXg[ui݁j


	ldi		data1,249

	mov		l_count1,data1
SR_LOOPB1:
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop

	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop

	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop

	nop
	nop
	nop
	nop
	nop
	nop
	dec		l_count1
	tst		l_count1
	brne	SR_LOOPB1		;249 * 40 = 9960clk


	ldi		data1,249

	mov		l_count1,data1
SR_LOOPB2:
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop

	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop

	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop

	nop
	nop
	nop
	nop
	nop
	nop
	dec		l_count1
	tst		l_count1
	brne	SR_LOOPB2		;9960 + 9960 = 9960clk


	ldi		data1,6

	mov		l_count1,data1
SR_LOOPB3:
	nop
	nop
	nop
	nop
	nop
	nop
	dec		l_count1
	tst		l_count1
	brne	SR_LOOPB3		;6 * 10 = 60clk

	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop

	sbi		PORTB,2			;vdXg[uグiݏIj
SR_B:						;@[v̓
	out		PORTD,sram_add	;rq`lւ̃AhXZbg
	subi	sram_add,-16	;ݐAhX{PU

	rjmp	SR_BL			;JԂi݂܂Ŗ[vj
							;20000NbN^1TCNi1j



	;*****                       *****
	;*****  O݂OTu  *****
	;*****                       *****
EX_INT0:

	cli				;荞݋֎~

	sbi		PORTB,2	;vdXg[uグiݏIj

	pop		data1
	pop		data1
					;荞݂ɂ߂AhXǂ

	rjmp	OUTPUT_RESULT
					;ʃXg̏o͂Ɉڂ





	;*****************************
	;*****  e[uނ̒`  *****
	;*****************************


	;*****  Œ蕶`  *****
.cseg


change_ok:
	.db		"change ok : ",0,0

error_command:
	.db		"error command : ",0,0

me:
	.db		"me,32768",0,0

sr:
	.db		"sr,12,s0,0.0000004,s1,0.0000005,s2,0.000001,",\
			"s3,0.000002,s4,000005,s5,0.00001,s6,0.00002,",\
			"s7,0.00005,s8,0.0001,s9,0.0002,sa,0.0005,",\
			"sb,0.001",0

tg:
	.db		"tg,3,t0,freerun,t1,fall edge,t2,rise edge",0




	;*****  S-RAM }bv`  *****

